function setSelectionRange(input, selectionStart, selectionEnd) {
  if (input.setSelectionRange) {
    input.focus();
    input.setSelectionRange(selectionStart, selectionEnd);
  }
  else if (input.createTextRange) {
    var range = input.createTextRange();
    range.collapse(true);
    range.moveEnd('character', selectionEnd);
    range.moveStart('character', selectionStart);
    range.select();
  }
}

function makeBold (input) {

if (input.setSelectionRange) {
    var selectionStart = input.selectionStart;
    var selectionEnd = input.selectionEnd;
    var selectionRange = input.value.substring(selectionStart,selectionEnd );
    input.value = input.value.substring(0, selectionStart)
                  + '<b>'
                  + selectionRange
                  + '</b>'
                  + input.value.substring(selectionEnd);
    if (selectionStart != selectionEnd) // has there been a selection
      setSelectionRange(input, selectionStart, selectionStart + selectionRange.length + 7);
    else // set caret
      setCaretToPos(input, selectionStart + selectionRange.length );
  }
  else if (document.selection) {
    var range = document.selection.createRange();
    if (range.parentElement() == input) {
      var isCollapsed = range.text == '';
      range.text = '<b>'+ range.text + '</b>';
      if (!isCollapsed)  { // there has been a selection
        range.moveStart('character', -selectionRange.length);
        range.select();
      }
    }
  }
}

function makeItalic(input) {


if (input.setSelectionRange) {
    var selectionStart = input.selectionStart;
    var selectionEnd = input.selectionEnd;
    var selectionRange = input.value.substring(selectionStart,selectionEnd );
    input.value = input.value.substring(0, selectionStart)
                  + '<i>'
                  + selectionRange
                  + '</i>'
                  + input.value.substring(selectionEnd);
    if (selectionStart != selectionEnd) // has there been a selection
      setSelectionRange(input, selectionStart, selectionStart + selectionRange.length + 7);
    else // set caret
      setCaretToPos(input, selectionStart + selectionRange.length );
  }
  else if (document.selection) {
    var range = document.selection.createRange();
    if (range.parentElement() == input) {
      var isCollapsed = range.text == '';
      range.text = '<i>'+ range.text + '</i>';
      if (!isCollapsed)  { // there has been a selection
        range.moveStart('character', -selectionRange.length);
        range.select();
      }
    }
  }
}

function makeUnderline (input) {


if (input.setSelectionRange) {
    var selectionStart = input.selectionStart;
    var selectionEnd = input.selectionEnd;
    var selectionRange = input.value.substring(selectionStart,selectionEnd );
    input.value = input.value.substring(0, selectionStart)
                  + '<u>'
                  + selectionRange
                  + '</u>'
                  + input.value.substring(selectionEnd);
    if (selectionStart != selectionEnd) // has there been a selection
      setSelectionRange(input, selectionStart, selectionStart + selectionRange.length + 7);
    else // set caret
      setCaretToPos(input, selectionStart + selectionRange.length );
  }
  else if (document.selection) {
    var range = document.selection.createRange();
    if (range.parentElement() == input) {
      var isCollapsed = range.text == '';
      range.text = '<u>'+ range.text + '</u>';
      if (!isCollapsed)  { // there has been a selection
        range.moveStart('character', -selectionRange.length);
        range.select();
      }
    }
  }
}
function autoscroll() {
window.scrollTo(0,99999999);
}
function show_it(layername) {
document.getElementById(layername).style.display = 'inline';
}
function hide_it(layername) {
document.getElementById(layername).style.display = 'none';
}
function history() {
popUp("index2.php?act=history");
}
function info() {
popUp("index2.php?act=info");
}
function refresh() {
window.location.href="index2.php";
}
function admin() {
popUp("admin.php");
}
function popUp(URL) {
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, '" + id + "', 'toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=0,width=900,height=1100,left = 580,top = 262');");
}
function addSmiley(code)
{
var comments = document.getElementById("tagmsg")
var cache = comments.value;
this.code = code;
comments.value = cache + ":" + code + ": ";
comments.focus();
}
